<iframe src="../.ibox.html?raw=true" style="border:none; position:fixed; width:40px; right:0; z-index=999;"></iframe>

# Cumulative Aggregation

To create a column which is the cumulative sum of another column, a table can be grown using the
`fold` command:
```plaintext
def accumulate Table (col:Str) {
    fold {range 0 1} {
	append-row { last get i | + { \$row | get $col } }
    } | skip 1 | ren i { \$col | + ' Cumulative' }
}
```

This implementation does the following:
1. It _folds_ over that table using a seed table with a single row of value zero (this is the
   `{range 0 1}` syntax. **The curly braces are crucial**,
2. For each fold, it _appends_ a number. The appending gets the last row and extracts the value in
   the `i` column. This was the previous value, and for the first row the previous value would be
   zero,
3. It adds that value to what is in column `$col` for the row,
4. After folding it skips the first row (since this was the seed row),
5. Renames the default 'i' column to '[Column Name] Cumulative'.

![](../assets/adv-pat.cum-agg.gif?raw=true)
